import React, { PropTypes } from 'react';
import { connect } from 'react-redux';
import selectn from 'selectn';

import checkboxChange from './checkboxChange';


export default ({
    Component
} = {}) => {

    const Container = React.createClass({

        displayName: `${Component.displayName}Container`,

        propTypes: {
            actionType: PropTypes.string.isRequired,
            path: PropTypes.string.isRequired,
            root: PropTypes.string.isRequired
        },

        render() {
            return (
                <Component { ...this.props } />
            );
        }

    });

    const mapStateToProps = (state, props) => {
        return {
            value: selectn(`${props.root}.${props.path}.value`, state.components)
        };
    };

    const mapDispatchToProps = (dispatch, props) => {
        return {
            onChange: (value) =>
                dispatch(checkboxChange({ path: props.path, root: props.root, type: props.actionType, value }))
        };
    };

    return connect(mapStateToProps, mapDispatchToProps)(Container);

};
