import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';
import invariant from 'invariant';

import isNullOrEmpty from '../../isNullOrEmpty';


import toNumber from '../../utils/toNumber';


export default ({
    block,
    displayName
}= {}) => {

    invariant(block !== undefined, 'Missing purebem block.');
    invariant(!isNullOrEmpty(displayName), 'Missing display name.');

    return React.createClass({

        displayName,

        mixins: [PureRenderMixin],

        propTypes: {
            onChange: PropTypes.func,
            type: PropTypes.oneOf(['number', 'text']),
            value: PropTypes.string
        },

        getDefaultProps() {
            return {
                onChange: () => {},
                type: 'text',
                value: ''
            };
        },

        onChange(evt) {
            const rawValue = evt.target.value;
            const { value, valid } = this.props.type === 'number'
                ? toNumber(rawValue)
                : { value: rawValue, valid: true };

            if (valid) {
                this.props.onChange({ rawValue, value });
            }
        },

        render() {
            const { value } = this.props;
            return (
                <input
                    type="text"
                    className={ block() }
                    onChange={ this.onChange }
                    value={ value } />
            );
        }

    });

};
