import invariant from 'invariant';

import getSeamlessPath from './getSeamlessPath';
import isObject from './isObject';


export default (foundation) => (state, action) => {
    if (!action.meta || action.meta.foundation !== foundation) {
        return state;
    }

    invariant(isObject(action.payload), `Payload should be an object (type: ${action.type}).`);

    const { path, root } = action.meta;
    return state.updateIn(getSeamlessPath(root, path), (obj) => {
        return {
            ...obj,
            ...action.payload
        };
    });
};
