import test from 'tape';

import toNumber from './toNumber';


test('non-number as string', (t) => {
    const result = toNumber('x');
    t.same(result, { value: '', valid: false });
    t.end();
});

test('number as string', (t) => {
    const result = toNumber('1');
    t.same(result, { value: 1, valid: true });
    t.end();
});

test('comma', (t) => {
    const result = toNumber('11,11');
    t.same(result, { value: 11.11, valid: true });
    t.end();
});

test('dot', (t) => {
    const result = toNumber('11.11');
    t.same(result, { value: 11.11, valid: true });
    t.end();
});

test('minus', (t) => {
    const result = toNumber('-');
    t.same(result, { value: 0, valid: true });
    t.end();
});

test('multiple minuses', (t) => {
    const result = toNumber('--');
    t.same(result, { value: '', valid: false });
    t.end();
});
